#pragma once
#include "syscalls.hpp"

namespace JabyEngine {
    namespace Callback {
        using Function = void (*)();

        struct VSyncCallback {
            static Function callback;

            static void install(Function function) {
                VSyncCallback::callback = function;
            }

            static void uninstall() {
                VSyncCallback::install(nullptr);
            }
        };

        struct DataReadyCallback {
            static Function callback;

            static void install(Function function) {
                DataReadyCallback::callback = function;
            }

            static void uninstall() {
                DataReadyCallback::install(nullptr);
            }
        };
    }
}