#include "../../internal-include/System/callbacks_internal.hpp"
#include "../../internal-include/CD/cd_internal.hpp"
#include <PSX/System/callbacks.hpp>

namespace JabyEngine {
    namespace Callback {
        Function VSyncCallback     :: callback = nullptr;
        Function DataReadyCallback :: callback = nullptr;

        namespace internal {
            namespace VSync {
                SysCall::ThreadHandle thread_handle    = 0;
                uint32_t              stack[StackSize] = {0};

                void routine() {
                    while(true) {
                        if(VSyncCallback::callback) {
                            VSyncCallback::callback();
                        }
                        SysCall::EnterCriticalSection();
                        MainThread::restore();
                    }
                }
            }

            namespace DataReady {
                SysCall::ThreadHandle thread_handle = 0;
                uint32_t              stack[StackSize];

                void routine() {
                    while(true) {
                        if(DataReadyCallback::callback) {
                            DataReadyCallback::callback();
                        }

                        CD::internal::IRQ::resume_at0(CD::internal::BCDTimeStamp::from(222));
                        CD::internal::NewCommand::send(CD_IO::Command::ReadS);

                        SysCall::EnterCriticalSection();
                        MainThread::restore();
                    }
                }
            }
        }
    }
}